/* eslint-disable */
// The eslint rules need to be cleaned up in another task, so we'll just disable them for now.
import React, { ElementType, forwardRef, FunctionComponent, Ref } from "react";
import { Grid, GridCell, GridContainer } from "../Grid/grid";

export interface LayoutGridContainerProps {
    /** Child elements. */
    children?: any;
    /** CSS class names. */
    className?: string;
    /** Ref to the component. */
    ref?: Ref<HTMLElement>;
    /** Customize the tag element (defaults to 'div'). */
    tag?: ElementType;
}

export const LayoutGridContainer: FunctionComponent<LayoutGridContainerProps> = forwardRef(
    (props, ref: Ref<HTMLElement>) => {
        // @ts-ignore Layout is an internal prop to avoid code duplication for LayoutGrid
        return <GridContainer layout ref={ref} {...props} />;
    }
);
export interface LayoutGridProps {
    /** Child elements. */
    children?: any;
    /** CSS class names. */
    className?: string;
    /** Ref to the component. */
    ref?: Ref<HTMLElement>;
    /** Customize the tag element (defaults to 'div'). */
    tag?: ElementType;
}

export const LayoutGrid: FunctionComponent<LayoutGridProps> = forwardRef(
    (props, ref: Ref<HTMLElement>) => {
        // @ts-ignore Layout is an internal prop to avoid code duplication for LayoutGrid
        return <Grid layout ref={ref} {...props} />;
    }
);

export interface LayoutGridCellProps {
    /** Child elements. */
    children?: any;
    /** CSS class names. */
    className?: string;
    /** Number of columns the cell spans on a large screen. */
    large?: number;
    /** Number of columns the cell spans on a medium screen. */
    medium?: number;
    /** Ref to the component. */
    ref?: Ref<HTMLElement>;
    /** Number of columns the cell spans on a small screen. */
    small?: number;
    /** Customize the tag element (defaults to 'div'). */
    tag?: ElementType;
};

export const LayoutGridCell: FunctionComponent<LayoutGridCellProps> = forwardRef(
    (props, ref: Ref<HTMLElement>) => {
        // @ts-ignore Layout is an internal prop to avoid code duplication for LayoutGrid
        return <GridCell layout ref={ref} {...props} />;
    }
);
